defmodule Wideact.Mixfile do
  use Mix.Project

  def project do
    [ app: :wideact,
    version: "0.0.2",
    elixir: "~> 1.2",
    build_embedded: Mix.env == :prod,
    start_permanent: Mix.env == :prod,
    deps: deps(),
    package: package(),
    description: description(),
    default_task: "run" ]
  end

  # Configuration for the OTP application
  #
  # Type "mix help compile.app" for more information
  def application do
    [ 
      mod: { Wideact, [ 40444 ] },
      applications: [:logger]
    ]
  end

  # Dependencies can be Hex packages:
  #
  #   {:mydep, "~> 0.3.0"}
  #
  # Or git/path repositories:
  #
  #   {:mydep, git: "https://github.com/elixir-lang/mydep.git", tag: "0.1.0"}
  #
  # Type "mix help deps" for more examples and options
  defp deps do
    [ {:ex_doc, ">= 0.0.0", only: :dev} ]
  end

  defp description do
    """
    Wideact is an inter-lingual actor system, enabling different languages to communicate seamlessly over the network. It implements a very primitive protocol, capable of only transmiting messages to named actors. It also serves with semi-persistence, and will save messages for an actor until they arrive.
    """
  end

  defp package do
    [
      name: :wideact,
      files: ["lib", "mix.exs", "README*", "LICENSE*", "config", "test"],
      maintainers: [ "Gavrilov Miroslav" ],
      licenses: [ "MIT" ],
      links: %{ "Github" => "https://github.com/gavrilovmiroslav/wideact" }
    ] 
  end
end
